Index: BLFS/libs/scripts.xsl
===================================================================
--- BLFS/libs/scripts.xsl	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ BLFS/libs/scripts.xsl	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -87,5 +87,5 @@
         <!-- Creating the scripts -->
       <exsl:document href="{$order}-z-{$filename}" method="text">
-        <xsl:text>#!/bin/sh&#xA;set -e&#xA;&#xA;</xsl:text>
+        <xsl:text>#!/bin/bash&#xA;set -e&#xA;&#xA;</xsl:text>
         <xsl:choose>
           <!-- Package page -->
Index: CLFS/master.sh
===================================================================
--- CLFS/master.sh	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ CLFS/master.sh	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 # $Id$
 
Index: CLFS2/clfs2.xsl
===================================================================
--- CLFS2/clfs2.xsl	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ CLFS2/clfs2.xsl	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -67,5 +67,5 @@
             <!-- Creating dirs and files -->
           <exsl:document href="{$dirname}/{$order}-{$filename}" method="text">
-            <xsl:text>#!/bin/sh&#xA;</xsl:text>
+            <xsl:text>#!/bin/bash&#xA;</xsl:text>
             <xsl:if test="not(@id='ch-system-stripping')">
               <xsl:text>set -e&#xA;&#xA;</xsl:text>
Index: CLFS2/master.sh
===================================================================
--- CLFS2/master.sh	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ CLFS2/master.sh	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 # $Id$
 
Index: CLFS3/clfs3.xsl
===================================================================
--- CLFS3/clfs3.xsl	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ CLFS3/clfs3.xsl	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -67,5 +67,5 @@
             <!-- Creating dirs and files -->
           <exsl:document href="{$dirname}/{$order}-{$filename}" method="text">
-            <xsl:text>#!/bin/sh&#xA;</xsl:text>
+            <xsl:text>#!/bin/bash&#xA;</xsl:text>
             <xsl:if test="not(@id='ch-system-stripping')">
               <xsl:text>set -e&#xA;&#xA;</xsl:text>
Index: CLFS3/master.sh
===================================================================
--- CLFS3/master.sh	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ CLFS3/master.sh	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 # $Id$
 
Index: HLFS/hlfs.xsl
===================================================================
--- HLFS/hlfs.xsl	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ HLFS/hlfs.xsl	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -92,8 +92,8 @@
           <xsl:when test="@id='ch-tools-stripping' or
                     @id='ch-system-strippingagain'">
-            <xsl:text>#!/bin/sh&#xA;</xsl:text>
+            <xsl:text>#!/bin/bash&#xA;</xsl:text>
           </xsl:when>
           <xsl:otherwise>
-            <xsl:text>#!/bin/sh&#xA;set -e&#xA;&#xA;</xsl:text>
+            <xsl:text>#!/bin/bash&#xA;set -e&#xA;&#xA;</xsl:text>
           </xsl:otherwise>
         </xsl:choose>
Index: HLFS/master.sh
===================================================================
--- HLFS/master.sh	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ HLFS/master.sh	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 set -e  # Enable error trapping
 
Index: LFS/lfs.xsl
===================================================================
--- LFS/lfs.xsl	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ LFS/lfs.xsl	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -83,8 +83,8 @@
           <xsl:when test="@id='ch-tools-stripping' or
                     @id='ch-system-strippingagain'">
-            <xsl:text>#!/bin/sh&#xA;</xsl:text>
+            <xsl:text>#!/bin/bash&#xA;</xsl:text>
           </xsl:when>
           <xsl:otherwise>
-            <xsl:text>#!/bin/sh&#xA;set -e&#xA;&#xA;</xsl:text>
+            <xsl:text>#!/bin/bash&#xA;set -e&#xA;&#xA;</xsl:text>
           </xsl:otherwise>
         </xsl:choose>
Index: LFS/master.sh
===================================================================
--- LFS/master.sh	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ LFS/master.sh	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 
 # $Id$
Index: common/blfs-tool-deps/901-libxml2
===================================================================
--- common/blfs-tool-deps/901-libxml2	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ common/blfs-tool-deps/901-libxml2	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 
 # $Id$
Index: common/blfs-tool-deps/902-libxslt
===================================================================
--- common/blfs-tool-deps/902-libxslt	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ common/blfs-tool-deps/902-libxslt	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 
 # $Id$
Index: common/blfs-tool-deps/903-tidy
===================================================================
--- common/blfs-tool-deps/903-tidy	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ common/blfs-tool-deps/903-tidy	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 
 # $Id$
Index: common/blfs-tool-deps/904-unzip
===================================================================
--- common/blfs-tool-deps/904-unzip	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ common/blfs-tool-deps/904-unzip	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 
 # $Id$
Index: common/blfs-tool-deps/905-docbook-xml
===================================================================
--- common/blfs-tool-deps/905-docbook-xml	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ common/blfs-tool-deps/905-docbook-xml	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 
 # $Id$
Index: common/blfs-tool-deps/906-docbook-xsl
===================================================================
--- common/blfs-tool-deps/906-docbook-xsl	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ common/blfs-tool-deps/906-docbook-xsl	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 
 # $Id$
Index: common/blfs-tool-deps/907-gpm
===================================================================
--- common/blfs-tool-deps/907-gpm	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ common/blfs-tool-deps/907-gpm	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 
 # $Id$
Index: common/blfs-tool-deps/908-links
===================================================================
--- common/blfs-tool-deps/908-links	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ common/blfs-tool-deps/908-links	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 
 # $Id$
Index: common/blfs-tool-deps/909-sudo
===================================================================
--- common/blfs-tool-deps/909-sudo	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ common/blfs-tool-deps/909-sudo	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 
 # $Id$
Index: common/blfs-tool-deps/910-wget
===================================================================
--- common/blfs-tool-deps/910-wget	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ common/blfs-tool-deps/910-wget	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 
 # $Id$
Index: common/blfs-tool-deps/911-subversion
===================================================================
--- common/blfs-tool-deps/911-subversion	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ common/blfs-tool-deps/911-subversion	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 
 # $Id$
Index: common/custom_pkgs
===================================================================
--- common/custom_pkgs	(revision 837797e92a586e7c147dfb91d19bf97810622edd)
+++ common/custom_pkgs	(revision 91ff6a9e0ca4d4bcc50854b2c0051a8a25d5b772)
@@ -1,3 +1,3 @@
-#!/bin/sh
+#!/bin/bash
 
 # $Id$
@@ -61,5 +61,5 @@
 xEOFx
 ) > custom-commands/scripts/$THIS_SCRIPT
-    
+
     else
     # Create an entry for package
@@ -91,5 +91,5 @@
 ) > custom-commands/scripts/$THIS_SCRIPT
     fi
-   
+
     chmod 755 custom-commands/scripts/$THIS_SCRIPT
     rm -f tmp
@@ -123,5 +123,5 @@
       # A cmd only script had no PKG defined
     [[ "x${PKG}" = "x" ]] && continue
-    
+
     echo "${URL} ${BLFS_SERVER}${PKG}/${PKG_FILE} ${MD5}" >> urls.lst.tmp
      # Add any patches..