Index: LFS/config
===================================================================
--- LFS/config	(revision bae64d8dae0751445186771cf8a05f08046ba756)
+++ LFS/config	(revision 95a954c0870c5b0ce645c02b93234097b84c6b1b)
@@ -11,8 +11,8 @@
 
 #--- Fully qualified path to a kernel config file
-# If no config file is  specified the kernel is NOT compiled
+# If no config file is specified the kernel is NOT compiled
 CONFIG=
 
-# Get the kernel package and patches even if no configutation file
+# Get the kernel package and patches even if no configuration file
 # has been supplied? 0(no)/1(yes)
 GETKERNEL=0
Index: README
===================================================================
--- README	(revision bae64d8dae0751445186771cf8a05f08046ba756)
+++ README	(revision 95a954c0870c5b0ce645c02b93234097b84c6b1b)
@@ -75,5 +75,5 @@
         the archive is incorrect jhalfs will access the net and download the
 	necessary version and store it here for later use. DO NOT set this to
-	$BUILDDIR/sources. If you do not set this variable to a valide directory
+	$BUILDDIR/sources. If you do not set this variable to a valid directory
 	ALL package tarballs will be downloaded from the 'net.
 
@@ -149,7 +149,7 @@
 
     Q. "How do I specify the build location?"
-    A. The original LFS document worked against the well know location /mnt/lfs.
+    A. The original LFS document worked against the well known location /mnt/lfs.
        This script automates the build of all of the LFS series of books and uses
-       a generic location $BUILDDIR with a default value a /mnt/build_dir.
+       a generic location $BUILDDIR with a default value of /mnt/build_dir.
        You may change this value to suit your needs.
 
@@ -176,5 +176,5 @@
        export SRC_ARCHIVE=/wherever/you/store/downloaded/packages
                        OR
-       you can change the setting in .common/config.
+       you can change the setting in common/config.
 
     Q. "Why have 2 copies of the files?"
@@ -195,5 +195,5 @@
        not the 'chroot.' You must transfer the toolchain to a sparc platform, reboot
        the sparc box and continue the build.
-       Of all the LFS series of books the Cross-LFS requires the greatest
+       Of all the LFS series of books Cross-LFS requires the greatest
        understanding of host/target hardware combination. Please read the book
        carefully and don't skip the easy parts (there are none..)
Index: TODO
===================================================================
--- TODO	(revision bae64d8dae0751445186771cf8a05f08046ba756)
+++ TODO	(revision 95a954c0870c5b0ce645c02b93234097b84c6b1b)
@@ -6,5 +6,5 @@
 -------------
 
-  - The BLFS moudule should can be called in conjunction with any of
+  - The BLFS module should be called in conjunction with any of
     LFS, CLFS or HLFS modules.
     Before working on that we need to fix the BLFS support.
@@ -32,7 +32,7 @@
 ------
 
-  - Add a Cunstomization file discussing how to hack the generated scripts
+  - Add a Customization file discussing how to hack the generated scripts
     and Makefiles, using the Cracklib support for Shadow in LFS as an example.
-    NOTE: that could require an special command line switch to regenerate the
+    NOTE: that could require a special command line switch to regenerate the
     Makefile if additional scripts are manually added to the *-commands/*/ dirs.
 
Index: common/common-functions
===================================================================
--- common/common-functions	(revision bae64d8dae0751445186771cf8a05f08046ba756)
+++ common/common-functions	(revision 95a954c0870c5b0ce645c02b93234097b84c6b1b)
@@ -57,5 +57,5 @@
           branch-NAME = a branch of name NAME
           VERSION = the version of a stable released book
-        To know what branches and stable books works with this version of jhalfs
+        To know what branches and stable books work with this version of jhalfs
         please see http://wiki.linuxfromscratch.org/alfs/wiki/SupportedBooks
 
@@ -88,5 +88,5 @@
         use the local working copy placed in DIR as the $(echo $PROGNAME | tr [a-z] [A-Z]) book
 
-${BOLD}  -C, --comparasion TYPE${OFF}
+${BOLD}  -C, --comparison TYPE${OFF}
          do iterative comparison analysis. This extends the total build time
          considerably because the entire final system will rebuild itself
@@ -95,5 +95,5 @@
            ICA   = do ICA as designed by Greg Schafer
            farce = do the farce analysis designed by Ken Moffat
-           both  = perfom both ICA and farce analysis
+           both  = perform both ICA and farce analysis
 
 ${BOLD}  -F, --fstab FILE${OFF}
@@ -109,5 +109,5 @@
 
 ${BOLD}  -R --rebuild${OFF}
-        clean the build directory before perfoming any other task. The directory
+        clean the build directory before performing any other task. The directory
         is cleaned only if it was populated by a previous jhalfs run.
 -EOF-
@@ -904,6 +904,6 @@
 
   if [[ -s MISSING_FILES.DMP ]]; then
-    echo  -e "\n\n${tab_}${RED} One or more files were not retrieved or have a bad MD5SUMS.\n${tab_} Check ${L_arrow}$BUILDDIR/sources/MISSING_FILES.DMP${R_arrow} for names ${OFF}\n"
-      # Do not allow the automatic exection of the Makefile.
+    echo  -e "\n\n${tab_}${RED} One or more files were not retrieved or have bad MD5SUMS.\n${tab_} Check ${L_arrow}$BUILDDIR/sources/MISSING_FILES.DMP${R_arrow} for names ${OFF}\n"
+      # Do not allow the automatic execution of the Makefile.
     echo "${tab_}${BOLD}${RED}*** ${YELLOW}Automatic execution of the generated makefile has been inhibited. ${RED}***${OFF}${nl_}"
     RUNMAKE=0
Index: common/makefile-functions
===================================================================
--- common/makefile-functions	(revision bae64d8dae0751445186771cf8a05f08046ba756)
+++ common/makefile-functions	(revision 95a954c0870c5b0ce645c02b93234097b84c6b1b)
@@ -66,5 +66,5 @@
   @echo -e \\t- Exit from the chroot.
   @echo
-  @echo -e \\t- Set-up the boot loader, except if building CLFS with METHOO=boot.
+  @echo -e \\t- Set-up the boot loader, except if building CLFS with METHOD=boot.
   @echo -e \\tYou can set-up the host bootloader or the new boot-loader
   @echo -e \\tinstalled on the new system.
Index: master.sh
===================================================================
--- master.sh	(revision bae64d8dae0751445186771cf8a05f08046ba756)
+++ master.sh	(revision 95a954c0870c5b0ce645c02b93234097b84c6b1b)
@@ -194,5 +194,5 @@
             BOOK=$1
           else
-            echo -e "\nLooks like $1 isn't a LFS working copy."
+            echo -e "\nLooks like $1 isn't an LFS working copy."
             exit 1
           fi
@@ -212,5 +212,5 @@
             BOOK=$1
           else
-            echo -e "\nLooks like $1 isn't a HLFS working copy."
+            echo -e "\nLooks like $1 isn't an HLFS working copy."
             exit 1
           fi
@@ -219,5 +219,5 @@
       ;;
 
-    --comparasion | -C )
+    --comparison | -C )
       test $# = 1 && eval "$exit_missing_arg"
       shift
@@ -347,5 +347,5 @@
           ;;
         * )
-          echo -e "\n$1 is an unknown or unsopported arch."
+          echo -e "\n$1 is an unknown or unsupported arch."
           exit 1
           ;;
@@ -412,5 +412,5 @@
 
 
-# Check for minumum gcc and kernel versions
+# Check for minimum gcc and kernel versions
 #check_requirements  1 # 0/1  0-do not display values.
 echo
@@ -495,5 +495,5 @@
   #
   if [[ -n "$FILES" ]]; then
-    # pushd/popd necessary to deal with mulitiple files
+    # pushd/popd necessary to deal with multiple files
     pushd $PACKAGE_DIR 1> /dev/null
       cp $FILES $JHALFSDIR/
@@ -503,5 +503,5 @@
   if [[ "$REPORT" = "1" ]]; then
     cp $COMMON_DIR/create-sbu_du-report.sh  $JHALFSDIR/
-    # After be sure that all look sane, dump the settings to a file
+    # After being sure that all looks sane, dump the settings to a file
     # This file will be used to create the REPORT header
     validate_config > $JHALFSDIR/jhalfs.config