Index: contrib/jhalfs-paco.patch
===================================================================
--- contrib/jhalfs-paco.patch	(revision c6653861dc6d662a491b8d101b2a8ea62c5c0e90)
+++ contrib/jhalfs-paco.patch	(revision 235f7e9c0286fdd9f5ea17aa9d78cfc1007bd62b)
@@ -1,7 +1,7 @@
 Index: LFS/master.sh
 ===================================================================
---- LFS/master.sh	(revision 2752)
+--- LFS/master.sh	(revision 2769)
 +++ LFS/master.sh	(working copy)
-@@ -176,6 +176,11 @@
+@@ -182,6 +182,11 @@
      # Keep the script file name
      this_script=`basename $file`
@@ -15,5 +15,5 @@
      # dependencies and target creation.
      case "${this_script}" in
-@@ -183,6 +188,18 @@
+@@ -189,6 +194,18 @@
        *stripping*) [[ "${STRIP}" = "0" ]] && continue ;;
      esac
@@ -34,5 +34,5 @@
      name=`echo ${this_script} | sed -e 's@[0-9]\{3\}-@@'`
  
-@@ -236,7 +253,9 @@
+@@ -242,7 +259,9 @@
      # and not to use chroot.
      case "${this_script}" in
@@ -45,5 +45,5 @@
  
      # Remove the build directory(ies) except if the package build fails.
-@@ -256,6 +275,16 @@
+@@ -262,6 +281,16 @@
      PREV=${this_script}${N}
      # Set system_build envar for iteration targets
@@ -62,5 +62,5 @@
  }
  
-@@ -316,8 +345,18 @@
+@@ -322,8 +351,18 @@
                else
                  wrt_run_as_chroot2 "$this_script" "$file"
@@ -83,5 +83,5 @@
 Index: LFS/lfs.xsl
 ===================================================================
---- LFS/lfs.xsl	(revision 2752)
+--- LFS/lfs.xsl	(revision 2769)
 +++ LFS/lfs.xsl	(working copy)
 @@ -32,6 +32,9 @@
@@ -148,5 +148,5 @@
 Index: common/config
 ===================================================================
---- common/config	(revision 2752)
+--- common/config	(revision 2769)
 +++ common/config	(working copy)
 @@ -84,6 +84,14 @@
@@ -177,5 +177,5 @@
 Index: common/func_validate_configs.sh
 ===================================================================
---- common/func_validate_configs.sh	(revision 2752)
+--- common/func_validate_configs.sh	(revision 2769)
 +++ common/func_validate_configs.sh	(working copy)
 @@ -84,9 +84,9 @@
@@ -433,5 +433,5 @@
 Index: common/common-functions
 ===================================================================
---- common/common-functions	(revision 2752)
+--- common/common-functions	(revision 2769)
 +++ common/common-functions	(working copy)
 @@ -65,6 +65,9 @@
@@ -445,5 +445,5 @@
          Optimize [0-2]
            0 = no optimization
-@@ -631,6 +634,7 @@
+@@ -645,6 +648,7 @@
                   --stringparam lc_all $LC_ALL \
                   --stringparam keymap $KEYMAP \
@@ -453,5 +453,5 @@
        ;;
      lfs)
-@@ -642,6 +646,7 @@
+@@ -656,6 +660,7 @@
                   --stringparam timezone $TIMEZONE \
                   --stringparam page $PAGE \
@@ -463,5 +463,5 @@
 Index: HLFS/hlfs.xsl
 ===================================================================
---- HLFS/hlfs.xsl	(revision 2752)
+--- HLFS/hlfs.xsl	(revision 2769)
 +++ HLFS/hlfs.xsl	(working copy)
 @@ -39,6 +39,9 @@
@@ -514,7 +514,7 @@
 Index: HLFS/master.sh
 ===================================================================
---- HLFS/master.sh	(revision 2752)
+--- HLFS/master.sh	(revision 2769)
 +++ HLFS/master.sh	(working copy)
-@@ -253,6 +253,11 @@
+@@ -259,6 +259,11 @@
      # Keep the script file name
      this_script=`basename $file`
@@ -528,5 +528,5 @@
      case $this_script in
          # We'll run the chroot commands differently than the others, so skip them in the
-@@ -262,6 +267,18 @@
+@@ -268,6 +273,18 @@
        *-stripping* )  [[ "$STRIP" = "0" ]] && continue ;;
      esac
@@ -547,5 +547,5 @@
      name=`echo $this_script | sed -e 's@[0-9]\{3\}-@@'`
  
-@@ -342,7 +359,9 @@
+@@ -348,7 +365,9 @@
          wrt_run_as_root "${this_script}" "${file}"
          ;;
@@ -557,5 +557,5 @@
      esac
      #
-@@ -375,6 +394,16 @@
+@@ -381,6 +400,16 @@
      PREV=${this_script}${N}
      # Set system_build envar for iteration targets
@@ -574,5 +574,5 @@
  
  }
-@@ -436,9 +465,20 @@
+@@ -442,9 +471,20 @@
          else  # Initialize the log and run the script
            wrt_run_as_chroot2 "${this_script}" "${file}"
@@ -597,5 +597,5 @@
 Index: master.sh
 ===================================================================
---- master.sh	(revision 2752)
+--- master.sh	(revision 2769)
 +++ master.sh	(working copy)
 @@ -148,6 +148,8 @@