Index: README
===================================================================
--- README	(revision 978286a4b96844e6f14da90db1b1742ff6da068e)
+++ README	(revision 327a3ee7ba2b636732b9a4ae31c7ec2f9606dee1)
@@ -15,8 +15,7 @@
       enough if you just want to build a base system as per the LFS book. It is
       also a required reading for all the other projects.
-    - README.CLFS: supplementary instructions to use the CLFS book series.
     - README.BLFS: instructions to install an automated build infrastructure
       for the BLFS book. There are two ways to do so: (i) install the
-      tools at the end of an LFS build (CLFS is not supported in that case), or
+      tools at the end of an LFS build, or
       (ii) install the tools on an already running system. Both methods are
       described in that file.
@@ -26,5 +25,5 @@
       available.
     - README.PACKAGE_MANAGEMENT: instructions to use package management during
-      the build (only for LFS, patches welcome for CLFS...)
+      the build
 
      Other sources of information are the context help in the menu interface,
@@ -169,35 +168,30 @@
 6. LAYOUT::
 
-        /BLFS (see README.BLFS)
-
-        /CLFS/master.sh
-             /clfs.xsl
-
-        /CLFS2/master.sh
-              /clfs2.xsl
-
-        /CLFS3/master.sh
-              /clfs3.xsl
+        /BLFS/* (see README.BLFS)
 
         /LFS/master.sh
             /lfs.xsl
 
-        /common/common_functions
+        /common/chroot.xsl
+               /common_functions
+               /create-sbu_du-report.sh
+               /hostreqs.xsl
+               /kernfs.xsl
                /makefile_functions
                /packages.xsl
+               /progress_bar.sh
                /urls.xsl
-               /create-sbu_du-report.sh
-               /progress_bar.sh
-               /blfs-tool-deps/9xx-*
                /libs/func_*
 
-        /custom/template
-               /config/
-               /examples/*
-               /examples_CLFS-E/*
+        /custom/examples/*
+               /config/* (needs to be created after cloning since it is an
+                          empty directory initially)
+               /template
 
         /extras/do_copy_files
                /do_ica_prep
                /do_ica_work
+
+        /menu/*
 
         /optimize/opt_config
@@ -206,21 +200,30 @@
                  /opt_config.d/noOpt
                               /noSymbols
+                              /O2pipe
                               /O3pipe
                               /O3pipe_march
                               /defOpt_fPIC
 
-        /menu/*
-
+        /pkgmngt/packageManager.xml.dpkg
+                /packageManager.xml.pacman
+                /packageManager.xml.porg
+                /packageManager.xml.template
+                /packInstall.sh.dpkg
+                /packInstall.sh.pacman
+                /packInstall.sh.porg
+                /packInstall.sh.template
+
+        CHEATSHEET
+        FUNCTION_LIST
+        LICENSE
         README
         README.BLFS
-        README.CLFS
         README.CUSTOM
+        README.PACKAGE_MANAGEMENT
         TODO
-        LICENSE
 
         Config.in
+        jhalfs
         Makefile
-        jhalfs
-        blfs-tool
 
 7. FAQ::
@@ -245,6 +248,5 @@
             jhalfs      (Makefile, cmd scripts, logs, etc..)
             sources     (where packages reside)
-            tools       (temporary bootstrap system)
-            cross-tools (temporary CLFS only)
+            tools       (temporary cross compiler)
                 ...
             FHS dir structure
@@ -271,5 +273,5 @@
     A. The package files must be visible during the chroot phase and this is a
        simple and reliable method of doing so. This method also handles the
-       CLFS boot build method where the final build may be done on a separate
+       boot build method where the final build may be done on a separate
        machine.
 
@@ -289,21 +291,4 @@
        after saving your original to .bashrc.XXX
 
-    Q. "When I try to build CLFS the Makefile fails at mid-point"
-    A. There could be numerous reasons for the failure but the most likely
-       reason is you are doing a cross-build using the 'chroot' method and the
-       target is not compatible with the host. If you choose to build using
-       the chroot method a test is performed at the end of the temptools
-       phase. If the test succeeds the build continues inside a chroot jail.
-       However if the test fails, it means the host and target are not
-       compatible an you should use the 'boot' method to create your target
-       code.
-       As an extreme example: You can build a sparc target on a x86 platform but
-       only the temptools phase. You must select the 'boot' method and not the
-       'chroot.' You must transfer the toolchain to a sparc platform, reboot the
-       sparc box and continue the build.
-       Of all the LFS series of books Cross-LFS requires the greatest
-       understanding of host/target hardware combination. Please read the book
-       carefully and don't skip the easy parts (there are none...)
-
     Q. "How could I stop the build at a predefined chosen point?"
     A. Launch the Makefile manually passing the last numbered target to be build