Index: LFS/lfs.xsl
===================================================================
--- LFS/lfs.xsl	(revision 55e82d2ae0411c3e82a9605577d1aceb8aced011)
+++ LFS/lfs.xsl	(revision 594ff3d878fc97ffd9eba862556311309263facf)
@@ -28,10 +28,4 @@
   -->
   <xsl:param name="testsuite" select="1"/>
-
-  <!-- Bomb on test suites failures?
-       n = no, I want to build the full system and review the logs
-       y = yes, bomb at the first test suite failure to can review the build dir
-  -->
-  <xsl:param name="bomb-testsuite" select="'n'"/>
 
   <!-- Install non wide character ncurses 5? -->
@@ -1122,57 +1116,31 @@
         </xsl:if>
         <xsl:choose>
-          <xsl:when test="$bomb-testsuite = 'n'">
-            <xsl:choose>
-              <xsl:when test="contains(string(), 'make -k')">
-                <xsl:value-of select="$instructions"/>
-                <xsl:if test="not($eof-seen)">
-                  <xsl:text> &gt;&gt; $TEST_LOG 2&gt;&amp;1 || true</xsl:text>
-                </xsl:if>
-                <xsl:text>&#xA;</xsl:text>
-              </xsl:when>
-              <xsl:when test="contains($instructions, 'make')">
-                <xsl:value-of select="substring-before($instructions, 'make')"/>
-                <xsl:text>make -k</xsl:text>
-                <xsl:value-of select="substring-after($instructions, 'make')"/>
-                <xsl:if test="not($eof-seen)">
-                  <xsl:text> &gt;&gt; $TEST_LOG 2&gt;&amp;1 || true</xsl:text>
-                </xsl:if>
-                <xsl:text>&#xA;</xsl:text>
-              </xsl:when>
-              <xsl:otherwise>
-                <xsl:value-of select="$instructions"/>
-                <xsl:if
-                  test="not(contains($instructions, '&gt;&gt;')) and
-                        not($eof-seen) and
-                        substring($instructions,
-                                  string-length($instructions)) != '\'">
-                  <xsl:text> &gt;&gt; $TEST_LOG 2&gt;&amp;1 || true</xsl:text>
-                </xsl:if>
-                <xsl:text>&#xA;</xsl:text>
-              </xsl:otherwise>
-            </xsl:choose>
+          <xsl:when test="contains(string(), 'make -k')">
+            <xsl:value-of select="$instructions"/>
+            <xsl:if test="not($eof-seen)">
+              <xsl:text> &gt;&gt; $TEST_LOG 2&gt;&amp;1 || true</xsl:text>
+            </xsl:if>
+            <xsl:text>&#xA;</xsl:text>
+          </xsl:when>
+          <xsl:when test="contains($instructions, 'make')">
+            <xsl:value-of select="substring-before($instructions, 'make')"/>
+            <xsl:text>make -k</xsl:text>
+            <xsl:value-of select="substring-after($instructions, 'make')"/>
+            <xsl:if test="not($eof-seen)">
+              <xsl:text> &gt;&gt; $TEST_LOG 2&gt;&amp;1 || true</xsl:text>
+            </xsl:if>
+            <xsl:text>&#xA;</xsl:text>
           </xsl:when>
           <xsl:otherwise>
-            <!-- bomb-testsuite != 'n'-->
-            <xsl:choose>
-              <xsl:when test="contains($instructions, 'make -k')">
-                <xsl:value-of select="$instructions"/>
-                <xsl:if test="not($eof-seen)">
-                  <xsl:text> &gt;&gt; $TEST_LOG 2&gt;&amp;1 || true</xsl:text>
-                </xsl:if>
-                <xsl:text>&#xA;</xsl:text>
-              </xsl:when>
-              <xsl:otherwise>
-                <xsl:value-of select="$instructions"/>
-                <xsl:if test="not(contains($instructions, '&gt;&gt;')) and
-                        not($eof-seen) and
-                        substring($instructions,
-                                  string-length($instructions)) != '\'">
-                  <xsl:text> &gt;&gt; $TEST_LOG 2&gt;&amp;1</xsl:text>
-                </xsl:if>
-                <xsl:text>&#xA;</xsl:text>
-              </xsl:otherwise>
-            </xsl:choose>
-          </xsl:otherwise> <!-- end not bomb-test=n -->
+            <xsl:value-of select="$instructions"/>
+            <xsl:if
+              test="not(contains($instructions, '&gt;&gt;')) and
+                    not($eof-seen) and
+                    substring($instructions,
+                              string-length($instructions)) != '\'">
+              <xsl:text> &gt;&gt; $TEST_LOG 2&gt;&amp;1 || true</xsl:text>
+            </xsl:if>
+            <xsl:text>&#xA;</xsl:text>
+          </xsl:otherwise>
         </xsl:choose>
       </xsl:otherwise>